>From aaea2c23e5abc288d46217be01e39668a82ff2b0 Mon Sep 17 00:00:00 2001
From: Andrew Wnuk <awnuk@redhat.com>
Date: Fri, 13 Jan 2012 12:18:44 -0800
Subject: [PATCH] Big numbers fix for CA and DRM.

This patch resolves multiple issues related to use of big numbers on CA and DRM
It also provides a fix for incomplete recovery requests causing null pointer exception.

Bugs: 756133, 758505.
---
 .../com/netscape/cms/servlet/cert/DoRevoke.java    |  206 +++++-----
 .../com/netscape/cms/servlet/cert/DoRevokeTPS.java |  131 +++----
 .../com/netscape/cms/servlet/cert/DoUnrevoke.java  |   64 ++--
 .../netscape/cms/servlet/cert/DoUnrevokeTPS.java   |   64 ++--
 .../cms/servlet/cert/GetCertFromRequest.java       |   11 +-
 .../cms/servlet/key/ConfirmRecoverBySerial.java    |   12 +-
 .../netscape/cms/servlet/key/DisplayBySerial.java  |   12 +-
 .../servlet/key/DisplayBySerialForRecovery.java    |   12 +-
 .../netscape/cms/servlet/key/KeyRecordParser.java  |    5 +-
 .../netscape/cms/servlet/key/RecoverBySerial.java  |   12 +-
 .../cms/servlet/request/CertReqParser.java         |    2 +-
 .../netscape/cms/servlet/request/CheckRequest.java |   23 +-
 .../cms/servlet/request/ProcessCertReq.java        |  407 ++++++++++----------
 .../netscape/cms/servlet/request/ProcessReq.java   |   28 +-
 .../com/netscape/cms/servlet/request/QueryReq.java |   70 ++--
 .../netscape/cms/servlet/request/ReqParser.java    |    5 +-
 16 files changed, 532 insertions(+), 532 deletions(-)

diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevoke.java b/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevoke.java
index 4c11d477d1b558a68516d08dc853195d4e5bf9a1..9e36d8b816159d1ff024183e61c0e4837b64bb8b 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevoke.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevoke.java
@@ -24,6 +24,7 @@ import java.util.Date;
 import java.util.Enumeration;
 import java.util.Locale;
 import java.util.Vector;
+import java.math.BigInteger;
 
 import javax.servlet.ServletConfig;
 import javax.servlet.ServletException;
@@ -195,20 +196,20 @@ public class DoRevoke extends CMSServlet {
         try {
             if (req.getParameter("revocationReason") != null) {
                 reason = Integer.parseInt(req.getParameter(
-                                "revocationReason"));
+                        "revocationReason"));
             }
             if (req.getParameter("totalRecordCount") != null) {
                 totalRecordCount = Integer.parseInt(req.getParameter(
-                                "totalRecordCount"));
+                        "totalRecordCount"));
             }
             if (req.getParameter("verifiedRecordCount") != null) {
                 verifiedRecordCount = Integer.parseInt(
-                            req.getParameter(
-                                    "verifiedRecordCount"));
+                        req.getParameter(
+                                "verifiedRecordCount"));
             }
             if (req.getParameter("invalidityDate") != null) {
                 long l = Long.parseLong(req.getParameter(
-                            "invalidityDate"));
+                        "invalidityDate"));
 
                 if (l > 0) {
                     invalidityDate = new Date(l);
@@ -229,7 +230,7 @@ public class DoRevoke extends CMSServlet {
                         user = (IUser) mUL.locateUser(new Certificates(certChain));
                     } catch (Exception e) {
                         CMS.debug("DoRevoke:  Failed to map certificate '" +
-                                   cert2.getSubjectDN().getName() + "' to user.");
+                                cert2.getSubjectDN().getName() + "' to user.");
                     }
                     if (mUG.isMemberOf(user, "Subsystem Group")) {
                         skipNonceVerification = true;
@@ -272,7 +273,7 @@ public class DoRevoke extends CMSServlet {
 
             try {
                 authzToken = authorize(mAclMethod, authToken,
-                            mAuthzResourceName, "revoke");
+                        mAuthzResourceName, "revoke");
             } catch (EAuthzAccessDenied e) {
                 log(ILogger.LL_FAILURE,
                         CMS.getLogMessage("ADMIN_SRVLT_AUTH_FAILURE", e.toString()));
@@ -495,12 +496,12 @@ public class DoRevoke extends CMSServlet {
 
                             // store a message in the signed audit log file
                             auditMessage = CMS.getLogMessage(
-                                        LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
-                                        auditSubjectID,
-                                        ILogger.FAILURE,
-                                        auditRequesterID,
-                                        auditSerialNumber,
-                                        auditRequestType);
+                                    LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
+                                    auditSubjectID,
+                                    ILogger.FAILURE,
+                                    auditRequesterID,
+                                    auditSerialNumber,
+                                    auditRequestType);
 
                             audit(auditMessage);
 
@@ -534,8 +535,8 @@ public class DoRevoke extends CMSServlet {
                 Vector serialNumbers = new Vector();
 
                 if (revokeAll != null && revokeAll.length() > 0) {
-                    for (int i = revokeAll.indexOf('='); i < revokeAll.length() && i > -1; 
-                            i = revokeAll.indexOf('=', i)) {
+                    for (int i = revokeAll.indexOf('='); i < revokeAll.length() && i > -1; i = revokeAll
+                            .indexOf('=', i)) {
                         if (i > -1) {
                             i++;
                             while (i < revokeAll.length() && revokeAll.charAt(i) == ' ') {
@@ -597,12 +598,12 @@ public class DoRevoke extends CMSServlet {
 
                         // store a message in the signed audit log file
                         auditMessage = CMS.getLogMessage(
-                                    LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
-                                    auditSubjectID,
-                                    ILogger.FAILURE,
-                                    auditRequesterID,
-                                    auditSerialNumber,
-                                    auditRequestType);
+                                LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
+                                auditSubjectID,
+                                ILogger.FAILURE,
+                                auditRequesterID,
+                                auditSerialNumber,
+                                auditRequestType);
 
                         audit(auditMessage);
 
@@ -638,12 +639,12 @@ public class DoRevoke extends CMSServlet {
 
                 // store a message in the signed audit log file
                 auditMessage = CMS.getLogMessage(
-                            LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
-                            auditSubjectID,
-                            ILogger.FAILURE,
-                            auditRequesterID,
-                            auditSerialNumber,
-                            auditRequestType);
+                        LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
+                        auditSubjectID,
+                        ILogger.FAILURE,
+                        auditRequesterID,
+                        auditSerialNumber,
+                        auditRequestType);
 
                 audit(auditMessage);
 
@@ -666,12 +667,12 @@ public class DoRevoke extends CMSServlet {
 
             // store a message in the signed audit log file
             auditMessage = CMS.getLogMessage(
-                        LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
-                        auditSubjectID,
-                        ILogger.SUCCESS,
-                        auditRequesterID,
-                        auditSerialNumber,
-                        auditRequestType);
+                    LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
+                    auditSubjectID,
+                    ILogger.SUCCESS,
+                    auditRequesterID,
+                    auditSerialNumber,
+                    auditRequestType);
 
             audit(auditMessage);
 
@@ -748,20 +749,20 @@ public class DoRevoke extends CMSServlet {
                     // if and only if "auditApprovalStatus" is
                     // "complete", "revoked", or "canceled"
                     if ((auditApprovalStatus.equals(
-                                RequestStatus.COMPLETE_STRING)) ||
+                            RequestStatus.COMPLETE_STRING)) ||
                             (auditApprovalStatus.equals(
                                     RequestStatus.REJECTED_STRING)) ||
                             (auditApprovalStatus.equals(
                                     RequestStatus.CANCELED_STRING))) {
                         auditMessage = CMS.getLogMessage(
-                                    LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST_PROCESSED,
-                                    auditSubjectID,
-                                    ILogger.FAILURE,
-                                    auditRequesterID,
-                                    auditSerialNumber,
-                                    auditRequestType,
-                                    auditReasonNum,
-                                    auditApprovalStatus);
+                                LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST_PROCESSED,
+                                auditSubjectID,
+                                ILogger.FAILURE,
+                                auditRequesterID,
+                                auditSerialNumber,
+                                auditRequestType,
+                                auditReasonNum,
+                                auditApprovalStatus);
 
                         audit(auditMessage);
                     }
@@ -968,14 +969,14 @@ public class DoRevoke extends CMSServlet {
                     || (auditApprovalStatus.equals(RequestStatus.REJECTED_STRING))
                     || (auditApprovalStatus.equals(RequestStatus.CANCELED_STRING))) {
                 auditMessage = CMS.getLogMessage(
-                            LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST_PROCESSED,
-                            auditSubjectID,
-                            ILogger.SUCCESS,
-                            auditRequesterID,
-                            auditSerialNumber,
-                            auditRequestType,
-                            auditReasonNum,
-                            auditApprovalStatus);
+                        LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST_PROCESSED,
+                        auditSubjectID,
+                        ILogger.SUCCESS,
+                        auditRequesterID,
+                        auditSerialNumber,
+                        auditRequestType,
+                        auditReasonNum,
+                        auditApprovalStatus);
 
                 audit(auditMessage);
             }
@@ -985,12 +986,12 @@ public class DoRevoke extends CMSServlet {
                 // store a "CERT_STATUS_CHANGE_REQUEST" failure
                 // message in the signed audit log file
                 auditMessage = CMS.getLogMessage(
-                            LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
-                            auditSubjectID,
-                            ILogger.FAILURE,
-                            auditRequesterID,
-                            auditSerialNumber,
-                            auditRequestType);
+                        LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
+                        auditSubjectID,
+                        ILogger.FAILURE,
+                        auditRequesterID,
+                        auditSerialNumber,
+                        auditRequestType);
 
                 audit(auditMessage);
             } else {
@@ -999,20 +1000,20 @@ public class DoRevoke extends CMSServlet {
                 // if and only if "auditApprovalStatus" is
                 // "complete", "revoked", or "canceled"
                 if ((auditApprovalStatus.equals(
-                            RequestStatus.COMPLETE_STRING)) ||
+                        RequestStatus.COMPLETE_STRING)) ||
                         (auditApprovalStatus.equals(
                                 RequestStatus.REJECTED_STRING)) ||
                         (auditApprovalStatus.equals(
                                 RequestStatus.CANCELED_STRING))) {
                     auditMessage = CMS.getLogMessage(
-                                LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST_PROCESSED,
-                                auditSubjectID,
-                                ILogger.FAILURE,
-                                auditRequesterID,
-                                auditSerialNumber,
-                                auditRequestType,
-                                auditReasonNum,
-                                auditApprovalStatus);
+                            LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST_PROCESSED,
+                            auditSubjectID,
+                            ILogger.FAILURE,
+                            auditRequesterID,
+                            auditSerialNumber,
+                            auditRequestType,
+                            auditReasonNum,
+                            auditApprovalStatus);
 
                     audit(auditMessage);
                 }
@@ -1026,12 +1027,12 @@ public class DoRevoke extends CMSServlet {
                 // store a "CERT_STATUS_CHANGE_REQUEST" failure
                 // message in the signed audit log file
                 auditMessage = CMS.getLogMessage(
-                            LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
-                            auditSubjectID,
-                            ILogger.FAILURE,
-                            auditRequesterID,
-                            auditSerialNumber,
-                            auditRequestType);
+                        LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
+                        auditSubjectID,
+                        ILogger.FAILURE,
+                        auditRequesterID,
+                        auditSerialNumber,
+                        auditRequestType);
 
                 audit(auditMessage);
             } else {
@@ -1040,20 +1041,20 @@ public class DoRevoke extends CMSServlet {
                 // if and only if "auditApprovalStatus" is
                 // "complete", "revoked", or "canceled"
                 if ((auditApprovalStatus.equals(
-                            RequestStatus.COMPLETE_STRING)) ||
+                        RequestStatus.COMPLETE_STRING)) ||
                         (auditApprovalStatus.equals(
                                 RequestStatus.REJECTED_STRING)) ||
                         (auditApprovalStatus.equals(
                                 RequestStatus.CANCELED_STRING))) {
                     auditMessage = CMS.getLogMessage(
-                                LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST_PROCESSED,
-                                auditSubjectID,
-                                ILogger.FAILURE,
-                                auditRequesterID,
-                                auditSerialNumber,
-                                auditRequestType,
-                                auditReasonNum,
-                                auditApprovalStatus);
+                            LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST_PROCESSED,
+                            auditSubjectID,
+                            ILogger.FAILURE,
+                            auditRequesterID,
+                            auditSerialNumber,
+                            auditRequestType,
+                            auditReasonNum,
+                            auditApprovalStatus);
 
                     audit(auditMessage);
                 }
@@ -1068,12 +1069,12 @@ public class DoRevoke extends CMSServlet {
                 // store a "CERT_STATUS_CHANGE_REQUEST" failure
                 // message in the signed audit log file
                 auditMessage = CMS.getLogMessage(
-                            LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
-                            auditSubjectID,
-                            ILogger.FAILURE,
-                            auditRequesterID,
-                            auditSerialNumber,
-                            auditRequestType);
+                        LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST,
+                        auditSubjectID,
+                        ILogger.FAILURE,
+                        auditRequesterID,
+                        auditSerialNumber,
+                        auditRequestType);
 
                 audit(auditMessage);
             } else {
@@ -1082,20 +1083,20 @@ public class DoRevoke extends CMSServlet {
                 // if and only if "auditApprovalStatus" is
                 // "complete", "revoked", or "canceled"
                 if ((auditApprovalStatus.equals(
-                            RequestStatus.COMPLETE_STRING)) ||
+                        RequestStatus.COMPLETE_STRING)) ||
                         (auditApprovalStatus.equals(
                                 RequestStatus.REJECTED_STRING)) ||
                         (auditApprovalStatus.equals(
                                 RequestStatus.CANCELED_STRING))) {
                     auditMessage = CMS.getLogMessage(
-                                LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST_PROCESSED,
-                                auditSubjectID,
-                                ILogger.FAILURE,
-                                auditRequesterID,
-                                auditSerialNumber,
-                                auditRequestType,
-                                auditReasonNum,
-                                auditApprovalStatus);
+                            LOGGING_SIGNED_AUDIT_CERT_STATUS_CHANGE_REQUEST_PROCESSED,
+                            auditSubjectID,
+                            ILogger.FAILURE,
+                            auditRequesterID,
+                            auditSerialNumber,
+                            auditRequestType,
+                            auditReasonNum,
+                            auditApprovalStatus);
 
                     audit(auditMessage);
                 }
@@ -1161,31 +1162,28 @@ public class DoRevoke extends CMSServlet {
 
             // find out if the value is hex or decimal
 
-            int value = -1;
+            BigInteger value = BigInteger.ONE.negate();
 
             //try int 
             try {
-                value = Integer.parseInt(serialNumber, 10);
+                value = new BigInteger(serialNumber, 10);
             } catch (NumberFormatException e) {
             }
 
             //try hex
-            if (value == -1) {
+            if (value.compareTo(BigInteger.ONE.negate()) == 0) {
                 try {
-                    value = Integer.parseInt(serialNumber, 16);
-
+                    value = new BigInteger(serialNumber, 16);
                 } catch (NumberFormatException e) {
                 }
             }
             // give up if it isn't hex or dec
-            if (value == -1) {
+            if (value.compareTo(BigInteger.ONE.negate()) == 0) {
                 throw new NumberFormatException();
             }
 
             // convert it to hexadecimal
-            serialNumber = "0x"
-                    + Integer.toHexString(
-                            value);
+            serialNumber = "0x" + value.toString(16);
         } else {
             serialNumber = ILogger.SIGNED_AUDIT_EMPTY_VALUE;
         }
